%define deftclver 8.4.2
%define tclver %(rpm -q tcl --queryformat '%%{version}' 2> /dev/null || echo %{deftclver})

#Module-Specific definitions
%define mod_version 1.0
%define release 1mdk
%define mod_name mod_tcl
%define mod_conf 27_%{mod_name}.conf
%define mod_so %{mod_name}.so
%define sourcename %{mod_name}-%{mod_version}

#New ADVX macros
%define ADVXdir %{_datadir}/ADVX
%{expand:%(cat %{ADVXdir}/ADVX-build)}
%{expand:%%global ap_version %(%{apxs} -q ap_version)}

# Standard Module Definitions
%define name %{ap_name}-%{mod_name}
%define version %{ap_version}_%{mod_version}

#Standard ADVX requires
Prereq:		%{ap_name} = %{ap_version}
Prereq:		%{ap_name}-conf
BuildPreReq:	ADVX-build >= 9.2
BuildRequires:	%{ap_name}-devel >= 2.0.43-5mdk
Provides: 	ADVXpackage
Provides:	AP20package

Summary:	Mod_tcl is a DSO module for the %{ap_name} Web server.
Name:		%{name}
Version:	%{version}
Release:	%{release}
Group:		System/Servers
Source0:	%{mod_name}.tar.bz2
Source1:	%{mod_conf}.bz2
Source2:	test_script.tm.bz2
Patch:		mod_tcl-fix-wild_name.bz2
License:	Apache License
URL:		http://tcl.apache.org/mod_tcl/
Prereq:		rpm-helper
Requires:	tcl = %{tclver}
BuildPrereq:	tcl = %{tclver}
Prereq:		tcl = %{tclver}
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
mod_tcl includes a Tcl interpreter into an Apache web servers
memory space, thus combining Tcl and Apache web server together.
This allows Apache to run Tcl scripts natively without having to
reload a Tcl interpreter every time the script is run. The Tcl
scripts are cached in the Tcl interpreter until the script file
modification time changes or Apache web server is restarted. Tcl
scripts using mod_tcl execute much faster than traditional CGI
scripts because they can avoid the initialization penalties that
traditional CGI scripts incur each time they are executed. mod_tcl
only needs to initialize an interpreter once at Apache web server
startup. Additionally mod_tcl exports the Apache API which allows
a programmer to have complete control over http requests that CGI
scripts can not provide.

%prep

%setup -q -n %{mod_name}-%{mod_version}
%patch0
bzcat %{SOURCE2} > test_script.tm

%build

cp tcl_core.c %{mod_name}.c 

# use stuff availble to determine stuff... :-)
. %{_libdir}/tclConfig.sh

#%{apxs} -c -I%{_includedir} -Wl,-ltcl8.3 -DHAVE_TCL_H %{mod_name}.c tcl_cmds.c tcl_misc.c
%{apxs} -c -I%{_includedir} -Wl,$TCL_LIB_FLAG -DHAVE_TCL_H %{mod_name}.c tcl_cmds.c tcl_misc.c

##############################################################################
# NOTE! As I don't know TCL, I don't have a clue how to use this
# module..., but anywhere here it is. The module may require
# other things I'm unaware of, please don't shoot me ;)
# -- 
# Regards // Oden Eriksson
# Deserve-IT Networks http://d-srv.com
##############################################################################

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%ADVXinstlib
%ADVXinstconf %{SOURCE1} %{mod_conf}
%ADVXinstdoc %{name}-%{version}

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post
%ADVXpost

%postun
%ADVXpost

%files
%defattr(-,root,root)
%doc AUTHORS INSTALL NEWS README test_script.tm
%config(noreplace) %{ap_confd}/%{mod_conf}
%{ap_extralibs}/%{mod_so}
%{ap_webdoc}/*

%changelog
* Thu Jul 10 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_1.0-1mdk
- rebuilt against latest apache2, requires and buildrequires

* Sat May 31 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.46_1.0-1mdk
- rebuilt for apache v2.0.46
- buildprereq ADVX-build >= 9.2

* Tue Apr 08 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.45_1.0-1mdk
- rebuilt against tcl-8.4.2
- cosmetic rebuild for apache v2.0.45 
- use %{_libdir}/tclConfig.sh to determine stuff...

* Sat Mar  1 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.44_1.0-3mdk
- fix segfault with names and wild_names record_rec structures when they are
  empty. 
- improve configuration file and test script.
- TODO: send these modifications to the mod_tcl team, since they are not MDK
  specific.

* Sat Mar  1 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.44_1.0-2mdk
- rebuild

* Tue Jan 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.44_1.0-1mdk
- rebuilt for apache v2.0.44

* Mon Jan 20 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_1.0-4mdk
- fix buildrequires apache2-devel >= 2.0.43-5mdk, as 
  pointed out by Olivier Thauvin

* Sat Jan 18 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_1.0-3mdk
- rebuilt against rebuilt buildrequires

* Mon Jan 13 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_1.0-2mdk
- Rebuilt with the new apache-devel that uses /usr/sbin/apxs2 and
  /usr/include/apache2

* Tue Nov 05 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_1.0-1mdk
- initial cooker contrib
